// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic', 'starter.controllers', 'starter.services', 'ionicPushwooshSample.services'])

.run(function($ionicPlatform, Pushwoosh) {
  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
      cordova.plugins.Keyboard.disableScroll(false);

    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleLightContent();
    }
    
    Pushwoosh.init();
  });
})

.config(function($stateProvider, $urlRouterProvider, $ionicConfigProvider) {

  $ionicConfigProvider.scrolling.jsScrolling(false);
  $ionicConfigProvider.tabs.position('bottom');


  // Ionic uses AngularUI Router which uses the concept of states
  // Learn more here: https://github.com/angular-ui/ui-router
  // Set up the various states which the app can be in.
  // Each state's controller can be found in controllers.js
  $stateProvider

  // setup an abstract state for the tabs directive
    .state('tab', {
    url: '/tab',
    abstract: true,
    templateUrl: 'templates/tabs.html'
  })

  // Each tab has its own nav history stack:

  .state('tab.news', {
    url: '/news',
    views: {
      'tab-news': {
        templateUrl: 'templates/tab-news.html',
        controller: 'NewsCtrl'
      }
    }
  })
  .state('tab.schedule', {
    url: '/schedule',
    views: {
      'tab-schedule': {
        templateUrl: 'templates/tab-schedule.html',
        controller: 'ScheduleCtrl'
      }
    }
  }) 
  .state('tab.schedule-detail', {
    url: "/schedule/:scheduleId",
    views: {
      'tab-schedule': {
        templateUrl: 'templates/single-schedule.html',
        controller: 'SingleScheduleCtrl'
      }      
    }	  
  }) 
  .state('tab.speaker-detail', {
    url: "/schedule/speaker/:speakerId",
    views: {
      'tab-schedule': {
        templateUrl: 'templates/single-speaker.html',
        controller: 'SingleSpeakerCtrl'
      }      
    }	  
  })      
  .state('tab.map', {
    url: '/map',
    views: {
      'tab-map': {
        templateUrl: 'templates/tab-map.html',
        controller: 'MapCtrl'
      }
    }
  })  
  .state('tab.sponsors', {
    url: '/sponsors',
    views: {
      'tab-sponsors': {
        templateUrl: 'templates/tab-sponsors.html',
        controller: 'SponsorsCtrl'
      }
    }
  }) 
  .state('tab.sponsor-detail', {
    url: "/sponsors/:sponsorId",
    views: {
      'tab-sponsors': {
        templateUrl: 'templates/single-sponsor.html',
        controller: 'SingleSponsorCtrl'
      }      
    }	  
  })   
  .state('tab.livestream', {
    url: '/livestream',
    views: {
      'tab-livestream': {
        templateUrl: 'templates/tab-livestream.html',
        controller: 'LivestreamCtrl'
      }
    }
  })  
  
  
  ;

  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/tab/news');

});
