angular.module('starter.controllers', ['ngCordova', 'ionic-toast'])
//Setup the environment constant...
.constant('ENVIRONMENT', (function(){
	
	return {
		url: 'https://conference.ses.edu/wp-admin/admin-ajax.php',
		//url: '/wp-admin/admin-ajax.php',
		secret: '53a87f24a7553500dd831c65d890ffc1'
	}
})())
.run(function(News, Options, $rootScope, $cordovaSQLite, Maps, Sponsors, Speakers, Schedule){
	document.addEventListener("resume", function(){
		$rootScope.$broadcast('newsRefresh');
		$rootScope.$broadcast('scheduleRefresh');
		$rootScope.$broadcast('speakerRefresh');
		$rootScope.$broadcast('mapRefresh');
		$rootScope.$broadcast('sponsorRefresh');		
	});	
	
	document.addEventListener("deviceready", function () {		
		//Open and create a database if none exists...
		db = $cordovaSQLite.openDB({ name: "sesconference2016.db", location: 'default' });
		//Create a table to store news that has been read...
		$cordovaSQLite.execute(db,"CREATE TABLE IF NOT EXISTS surveycompleted (id text primary key)");	
		$cordovaSQLite.execute(db,"CREATE TABLE IF NOT EXISTS myschedule (id text primary key)");
		$cordovaSQLite.execute(db,"CREATE TABLE IF NOT EXISTS livestream (id text primary key)");	

		query = "SELECT id from livestream";
		
		$cordovaSQLite.execute(db,query,[]).then(function(result) {
			if(result.rows.length > 0)
			{
				redeemedCode = true;
				$rootScope.$broadcast('livestreamRefresh');	
			}
		}, function(error) {
		});			

		query = "SELECT id from surveycompleted";
		
		$cordovaSQLite.execute(db,query,[]).then(function(result) {
			if(result.rows.length > 0)
			{
				for(var i=0; i < result.rows.length; i++)
				{
					surveysTaken.push(result.rows.item(i).id);
				}
			}
		}, function(error) {
		});					

		query = "SELECT id from myschedule";
		
		$cordovaSQLite.execute(db,query,[]).then(function(result) {
			if(result.rows.length > 0)
			{
				for(var i=0; i < result.rows.length; i++)
				{
					sessionsScheduled.push(result.rows.item(i).id);
				}
			}
		}, function(error) {
		});								
	}, false);				
	
	//Fetch the initial news for the site...
	News.fetchAll("1").then(function(data){
		newsCache = data;	
	});
	
	//Fetch the options for the site...
	Options.fetchAll().then(function(data){
		optionsCache = data;	
	});
	
	//Fetch the maps for the site...
	Maps.fetchAll().then(function(data){
		mapsCache = data;	
	});
	
	//Fetch the sponsors for the site...
	Sponsors.fetchAll().then(function(data){
		sponsorCache = data;	
	});		
	
	//Fetch the speakers for the site...
	Speakers.fetchAll().then(function(data){
		speakerCache = data;	
	});	
	
	//Fetch the schedule for the site...
	Schedule.fetchAll().then(function(data){
		scheduleCache = data;	
	});								
})
.controller('NewsCtrl', function($scope, $stateParams, $ionicModal, $rootScope, News, Options, SocialMediaPost) {
	$rootScope.$on('newsRefresh', function(){
		$scope.currentPage = 1;
		$scope.moreData = true;
		News.fetchAll($scope.currentPage).then(function(data){
			$scope.news = data;
			$scope.currentPage += 1;

			newsCache = $scope.news;
			newsCurrentPage = $scope.currentPage;						
		});	
	});
				
	$scope.loadMore = function(){
		News.fetchAll($scope.currentPage).then(function(data){
			if(data.length)
			{
				$scope.news = $scope.news.concat(data);
				$scope.currentPage += 1;
				
				newsCache = $scope.news;
				newsMoreData = $scope.moreData;
				newsCurrentPage = $scope.currentPage;											
			}
			else
			{
				$scope.moreData = false;
				newsMoreData = $scope.moreData;
			}
			$scope.$broadcast('scroll.infiniteScrollComplete');
		});					
	};
	
	$scope.currentPage = 1;
	$scope.moreData = true;
	$scope.news = [];
	
	if(newsCache)
	{
		$scope.news = newsCache;
		$scope.currentPage = 2;
		
		if(newsCurrentPage)
		{
			$scope.currentPage = newsCurrentPage;
		}
		
		if(newsMoreData)
		{
			$scope.moreData = newsMoreData;
		}
	}
	else
	{
		News.fetchAll($scope.currentPage).then(function(data){
			$scope.news = data;
			$scope.currentPage += 1;

			newsCache = $scope.news;
			newsCurrentPage = $scope.currentPage;							
		});		
    }
	    
    
  $scope.sortNews = function(newsItem){
	var date = new Date(newsItem.posted);
	return date;  
  }
  
  $scope.shareSingleNews = function(e, title){
  	e.preventDefault();
  	
  	SocialMediaPost.signalSinglePost(title);
  }
  
  $scope.shareGenericPost = function(){
	  SocialMediaPost.signalGenericPost();
  }
  
  $scope.openSocialLink = function(e, platform){
	  e.preventDefault();
	  
	  if(platform == 'facebook')
	  {
		   window.open(optionsCache.facebooklink, '_system', 'location=yes');
	  }
	  else
	  {
		   window.open(optionsCache.twitterlink, '_system', 'location=yes');
	  }
  }
   
  $scope.refreshNews = function(){
		News.fetchAll().then(function(data){
			$scope.news = data;
			$scope.currentPage = 2;
			$scope.moreData = true;
			
			newsCache = $scope.news;
			newsMoreData = $scope.moreData;
			newsCurrentPage = $scope.currentPage;
						
		}).finally(function(){
			$scope.$broadcast('scroll.refreshComplete');	
		});		  
  }
   
  $scope.openModal = function(id) {
	News.getNews(id).then(function(data){
		$scope.data = data;
	  
		$ionicModal.fromTemplateUrl('templates/single-news.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
			$scope.modal.show();
		});		
	});
  };
  
  $scope.closeModal = function() {
    $scope.modal.hide();
  };
  
  // Cleanup the modal when we're done with it!
  $scope.$on('$destroy', function() {
	  if($scope.modal)
	  {
	  	$scope.modal.remove();
	  	$scope.data = null;
	  }
  });
})
.controller('SingleNewsCtrl', function($scope, $stateParams) {
   jQuery(document).on('click', '.external-link', function (e) {
	  e.preventDefault();
      var link = $(this).attr('href');
      window.open(link, '_system', 'location=yes');
     return false;
   });
})
.controller('ScheduleCtrl', function($scope, $stateParams, $cordovaSQLite, $rootScope, $ionicScrollDelegate, Schedule, Speakers, SocialMediaPost) {
	$scope.days = [];
	$scope.times = [];
	$scope.mySchedule = [];
	$scope.myTimes = [];
	$scope.myDays = [];
	$scope.activeTabs = [true, false, false];
	
    $scope.shareGenericPost = function(){
	    SocialMediaPost.signalGenericPost();
    }	
	
	$scope.showTab = function(e, index){
		e.preventDefault();
		
		$scope.activeTabs = [false, false, false];
		$scope.activeTabs[index] = true;
		
		$ionicScrollDelegate.scrollTop();		
	}
	
	$scope.checkTab = function(index){
		if($scope.activeTabs[index])
		{
			return true;
		}
		else
		{
			return false;
		}		
	}
	
	$scope.activeTab = function(index){
		if($scope.activeTabs[index])
		{
			if(index == 0)
			{
				angular.element( document.querySelector( '#sub-header' ) ).removeClass('second').removeClass('third').addClass('first');
				return 'active';	
			}
			else if (index == 1)
			{
				angular.element( document.querySelector( '#sub-header' ) ).removeClass('first').removeClass('third').addClass('second');
				return 'active';	
			}
			else if(index == 2)
			{
				angular.element( document.querySelector( '#sub-header' ) ).removeClass('first').removeClass('second').addClass('third');
				return 'active';	
			}
		}
	}
	
	$rootScope.$on('scheduleRefresh', function(){	
		j=0;
	
		$scope.myDays = [];
		$scope.myTimes = [];
		$scope.mySchedule = [];
		
		$scope.schedule.forEach(function(schedule){
			if(sessionsScheduled.indexOf(schedule.id) != -1)
			{
				$scope.schedule[j].added = 1;
				$scope.mySchedule.push($scope.schedule[j]);
				
				if($scope.myDays.length == 0)
				{
					$scope.myDays.push(Date.parse(schedule.date));
				}
				else if($scope.myDays.indexOf(Date.parse(schedule.date)) == -1)
				{
					$scope.myDays.push(Date.parse(schedule.date));
				}
				
				var foundSlot = false;
				
				if($scope.myTimes.length == 0)
				{
					$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
				}
				else
				{
					$scope.myTimes.forEach(function(timeSlot){
						if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
						{
							foundSlot = true;
						}
					});
					
					if(!foundSlot)
					{
						$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
					}
				}				
			}
			else
			{
				$scope.schedule[j].added = 0;				
			}
			
			j++;
		});			
	});	
	
	$scope.refreshSchedule = function(){
		if($scope.activeTabs[0] == true)
		{
			Schedule.fetchAll().then(function(data){
				$scope.schedule = data;
				
				scheduleCache = $scope.schedule;
				
				i=0;
				
				$scope.schedule.forEach(function(schedule){
					if($scope.days.indexOf(Date.parse(schedule.date)) == -1)
					{
						$scope.days.push(Date.parse(schedule.date));
					}
					
					if($scope.times.length == 0)
					{
						$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});	
					}
					else
					{
						var foundSlot = false;
						
						$scope.times.forEach(function(timeSlot){
							if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
							{
								foundSlot = true;
							}
						});
						
						if(!foundSlot)
						{
							$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});
						}
					}
	
					if(sessionsScheduled.indexOf(schedule.id) != -1)
					{
						$scope.schedule[i].added = 1;
					}
					else
					{
						$scope.schedule[i].added = 0;
					}
					
					i++;
				});				
							
			}).finally(function(){
				$scope.$broadcast('scroll.refreshComplete');	
			});	
		}
		else
		{
			Speakers.fetchAll().then(function(data){
				$scope.speakers = data;
				
				speakerCache = $scope.speakers;
							
			}).finally(function(){
				$scope.$broadcast('scroll.refreshComplete');	
			});				
		}		
	}
	
	$rootScope.$on('speakerRefresh', function(){
		Speakers.fetchAll().then(function(data){
			$scope.speakers = data;
			
			speakerCache = $scope.speakers;			
		});
	});	
		
	$scope.sortDays = function(day){
		var date = new Date(day);
		return date;  
	}
	
	$scope.sortTimes = function(timeSlot){
		var time = new Date(timeSlot.date + ' ' + timeSlot.start);
		
		return time;
	}
	
	$scope.filterSchedule = function(day, startTime){
		return function(item){
			var found = false;
			
			if(Date.parse(item.date) == day && item.start == startTime)
			{
				found = true;
			}
			
			return found;
		}		
	}
	
	$scope.filterTime = function(day){
		return function(time){
			var found = false;
			
			if(Date.parse(time.date) == day)
			{
				found = true;
			}
			
			return found;
		}
	}
	
	$scope.removeFromSchedule = function(e, id){
		e.preventDefault();
		
		query = "DELETE FROM myschedule WHERE id = ?";
		
		$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
			sessionsScheduled.splice(sessionsScheduled.indexOf(id), 1);	
			
			i=0;
			
			$scope.schedule.forEach(function(schedule){
				if($scope.schedule[i].id == id)
				{
					$scope.schedule[i].added = 0;
				}
				
				i++;
			});
			
			i=0;
			
			$scope.mySchedule.forEach(function(schedule){
				if($scope.mySchedule[i].id == id)
				{
					$scope.mySchedule.splice(i, 1);
				}
				
				i++;
			});
			
			
			i=0;
			
			$scope.myDays.forEach(function(day){
				var foundDay = false;
				
				$scope.mySchedule.forEach(function(schedule){
					if(day == Date.parse(schedule.date))
					{
						foundDay = true;
					}
				});
				
				if(!foundDay)
				{
					$scope.myDays.splice(i, 1);
				}
				
				i++;
			});							
				
			i=0;
				
			$scope.myTimes.forEach(function(timeSlot){
				var foundSlot = false;
				
				$scope.mySchedule.forEach(function(schedule){
					if(timeSlot.start == schedule.start)
					{
						foundSlot = true;
					}
				});
				
				if(!foundSlot)
				{
					$scope.myTimes.splice(i, 1);
				}
				
				i++;
			});			
					
    	}, function (err) {
    	});				
	}
	
	$scope.addToSchedule = function(e, id){
		e.preventDefault();
		
		db = $cordovaSQLite.openDB({ name: "sesconference2016.db", location: 'default' });
		
		if(sessionsScheduled.indexOf(id) != -1)
		{
			query = "DELETE FROM myschedule WHERE id = ?";
			
			$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
				i=0;
				
				sessionsScheduled.splice(sessionsScheduled.indexOf(id), 1);	
				
				$scope.schedule.forEach(function(schedule){
					if($scope.schedule[i].id == id)
					{
						$scope.schedule[i].added = 0;						
					}
					
					i++;
				});	
				
				i=0;
				
				$scope.mySchedule.forEach(function(schedule){
					if($scope.mySchedule[i].id == id)
					{
						$scope.mySchedule.splice(i, 1);
					}
					
					i++;
				});

				i=0;
				
				$scope.myDays.forEach(function(day){
					var foundDay = false;
					
					$scope.mySchedule.forEach(function(schedule){
						if(day == Date.parse(schedule.date))
						{
							foundDay = true;
						}
					});
					
					if(!foundDay)
					{
						$scope.myDays.splice(i, 1);
					}
					
					i++;
				});							
				
				i=0;
				
				$scope.myTimes.forEach(function(timeSlot){
					var foundSlot = false;
					
					$scope.mySchedule.forEach(function(schedule){
						if(timeSlot.start == schedule.start)
						{
							foundSlot = true;
						}
					});
					
					if(!foundSlot)
					{
						$scope.myTimes.splice(i, 1);
					}
					
					i++;
				});
						
	    	}, function (err) {
	    	});				
		}
		else
		{
			query = "INSERT OR IGNORE INTO myschedule (id) VALUES (?)";
			
			$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
				i=0;
				
				sessionsScheduled.push(id);	
				
				$scope.schedule.forEach(function(schedule){
					if($scope.schedule[i].id == id)
					{
						$scope.schedule[i].added = 1;
						$scope.mySchedule.push($scope.schedule[i]);
						
						if($scope.myDays.length == 0)
						{
							$scope.myDays.push(Date.parse(schedule.date));
						}
						else if($scope.myDays.indexOf(Date.parse(schedule.date)) == -1)
						{
							$scope.myDays.push(Date.parse(schedule.date));
						}
						
						var foundSlot = false;
						
						if($scope.myTimes.length == 0)
						{
							$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
						}
						else
						{
							$scope.myTimes.forEach(function(timeSlot){
								if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
								{
									foundSlot = true;
								}
							});
							
							if(!foundSlot)
							{
								$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
							}
						}							
						
					}
					
					i++;
				});				
	
	    	}, function (err) {
	    	});			
		}	
	}
	
	if(speakerCache)
	{
		$scope.speakers = speakerCache;
	}
	else
	{
		Speakers.fetchAll().then(function(data){
			$scope.speakers = data;
			speakerCache = $scope.speakers;
		});		
	}
		
	if(scheduleCache)
	{
		$scope.schedule = scheduleCache;
		i=0;
		
		$scope.schedule.forEach(function(schedule){
			if($scope.days.indexOf(Date.parse(schedule.date)) == -1)
			{
				$scope.days.push(Date.parse(schedule.date));
			}
			
			if($scope.times.length == 0)
			{
				$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});	
			}
			else
			{
				var foundSlot = false;
				
				$scope.times.forEach(function(timeSlot){
					if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
					{
						foundSlot = true;
					}
				});
				
				if(!foundSlot)
				{
					$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});
				}
			}
			
			if(sessionsScheduled.indexOf(schedule.id) != -1)
			{
				if($scope.myDays.length == 0)
				{
					$scope.myDays.push(Date.parse(schedule.date));
				}
				else if($scope.myDays.indexOf(Date.parse(schedule.date)) == -1)
				{
					$scope.myDays.push(Date.parse(schedule.date));
				}
				
				var foundSlot = false;
				
				if($scope.myTimes.length == 0)
				{
					$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
				}
				else
				{
					$scope.myTimes.forEach(function(timeSlot){
						if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
						{
							foundSlot = true;
						}
					});
					
					if(!foundSlot)
					{
						$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
					}
				}					
			}			
			
			if(sessionsScheduled.indexOf(schedule.id) != -1)
			{
				$scope.schedule[i].added = 1;
				$scope.mySchedule.push($scope.schedule[i]);
			}
			else
			{
				$scope.schedule[i].added = 0;
			}
			
			i++;
		});			
	}
	else
	{
		Schedule.fetchAll().then(function(data){
			$scope.schedule = data;
			scheduleCache = $scope.schedule;
			
			i=0;
			
			$scope.schedule.forEach(function(schedule){
				if($scope.days.indexOf(Date.parse(schedule.date)) == -1)
				{
					$scope.days.push(Date.parse(schedule.date));
				}
				
				if($scope.times.length == 0)
				{
					$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});	
				}
				else
				{
					var foundSlot = false;
					
					$scope.times.forEach(function(timeSlot){
						if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
						{
							foundSlot = true;
						}
					});
					
					if(!foundSlot)
					{
						$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});
					}
				}
				
				if(sessionsScheduled.indexOf(schedule.id) != -1)
				{
					if($scope.myDays.length == 0)
					{
						$scope.myDays.push(Date.parse(schedule.date));
					}
					else if($scope.myDays.indexOf(Date.parse(schedule.date)) == -1)
					{
						$scope.myDays.push(Date.parse(schedule.date));
					}
					
					var foundSlot = false;
					
					if($scope.myTimes.length == 0)
					{
						$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
					}
					else
					{
						$scope.myTimes.forEach(function(timeSlot){
							if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
							{
								foundSlot = true;
							}
						});
						
						if(!foundSlot)
						{
							$scope.myTimes.push({date: schedule.date, start: schedule.start, end: schedule.end});
						}
					}					
				}

				if(sessionsScheduled.indexOf(schedule.id) != -1)
				{
					$scope.schedule[i].added = 1;
					$scope.mySchedule.push($scope.schedule[i]);
				}
				else
				{
					$scope.schedule[i].added = 0;
				}
				
				i++;
			});				
		});			
	}

})
.controller('SingleScheduleCtrl', function($scope, $stateParams, $ionicModal, $timeout, $ionicHistory, $cordovaSQLite, $rootScope, Schedule){
 	Schedule.fetchSingle($stateParams.scheduleId).then(function(data){
		$scope.schedule = data;
		$scope.surveyButton = {};
		
		if(surveysTaken.indexOf($scope.schedule.id) == -1)
		{
			$scope.surveyButton.show = true;
		}
		else
		{
			$scope.surveyButton.show = false;
		}
		
		if($scope.surveyButton.show == true)
		{
			currentDateTime = moment(Date.now());
			sessionDateInformation = new Date($scope.schedule.date + ' ' + $scope.schedule.start);
			
			if(sessionDateInformation.getMonth() <= 8)
			{
				month = '0' + (sessionDateInformation.getMonth() + 1);
			}
			else
			{
				month = sessionDateInformation.getMonth() + 1;
			}
			
			if(sessionDateInformation.getDate() <= 9)
			{
				day = '0' + sessionDateInformation.getDate();
			}
			else
			{
				day = sessionDateInformation.getDate();
			}			
	
			if(sessionDateInformation.getHours() <= 9)
			{
				hour = '0' + sessionDateInformation.getHours();
			}
			else
			{
				hour = sessionDateInformation.getHours() + 1;
			}		
	
			sessionDateTime = sessionDateInformation.getFullYear() + '-' + month + '-' + day + ' ' + hour + ':' + sessionDateInformation.getMinutes() + ':' + sessionDateInformation.getSeconds();
	   
			currentDateTimeLocal = moment.tz(currentDateTime, 'America/New_York').format('YYYY-MM-DDTkk:mm:ss');	
			sessionDateTimeLocal = moment.tz(sessionDateTime, 'America/New_York').add(10, 'minutes').format('YYYY-MM-DDTkk:mm:ss');
			
			currentDateObject = new Date(currentDateTimeLocal);
			sessionDateObject = new Date(sessionDateTimeLocal);
					
			if(currentDateObject > sessionDateObject)
			{
				$scope.surveyButton.show = true;
			}
			else
			{
				$scope.surveyButton.show = false;
			}
		}		
	});
	
	$scope.goBack = function(){
		$ionicHistory.goBack();
	}
	
	$scope.addToSchedule = function(e, id){
		e.preventDefault();
		
		db = $cordovaSQLite.openDB({ name: "sesconference2016.db", location: 'default' });
		i=0;
		
		if(sessionsScheduled.indexOf(id) != -1)
		{
			query = "DELETE FROM myschedule WHERE id = ?";
			
			$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
				sessionsScheduled.splice(sessionsScheduled.indexOf(id), 1);
				$scope.schedule.added = 0;	
				$rootScope.$broadcast('scheduleRefresh');					
	    	}, function (err) {
	    	});				
		}
		else
		{
			query = "INSERT OR IGNORE INTO myschedule (id) VALUES (?)";
			
			$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
				sessionsScheduled.push(id);	
				$scope.schedule.added = 1;	
				$rootScope.$broadcast('scheduleRefresh');					
	    	}, function (err) {
	    	});			
		}	
	}
		
	$scope.options = {
		loop: false,
		pagination: '.custom-swiper-pagination',
        paginationClickable: true
	}
	
	$scope.$on("$ionicSlides.sliderInitialized", function(event, data){
	  $scope.slider = data.slider;
	});	
	
	$scope.showSurvey = function(e){
		e.preventDefault();
		
		$ionicModal.fromTemplateUrl('templates/survey.html', {
			scope: $scope,
			animation: 'slide-in-up'
		}).then(function(modal) {
			$scope.modal = modal;
			$scope.modal.show();
		});		
	}
	
	$scope.displayMaterials = function(e, url){
	    e.preventDefault();

	    if(ionic.Platform.isIOS())
	    {
	    	fileUrl = url;
	    	window.open(fileUrl, '_blank', 'location=no,EnableViewPortScale=yes');
	    }
	    else
	    {
			fileUrl = url;
			window.open('https://docs.google.com/viewer?url=' + fileUrl + '&embedded=true', '_blank', 'location=no');
	    }			    
	}
	    
	$scope.closeModal = function(e) {
		e.preventDefault();
		
		$scope.modal.hide();
		
		$timeout(function(){
		    $scope.modal.remove();
		}, 500)
	};
	
   jQuery(document).on('click', '.external-link', function (e) {
	  e.preventDefault();
      var link = $(this).attr('href');
      window.open(link, '_system', 'location=yes');
     return false;
   });	   				
})
.controller('SingleSpeakerCtrl', function($scope, $stateParams, $ionicHistory, $ionicModal, $cordovaSQLite, $timeout, $rootScope, Speakers) {
	$scope.days = [];
	$scope.times = [];
	$scope.expanded = false;
	
 	Speakers.fetchSingle($stateParams.speakerId).then(function(data){
		$scope.speaker = data;
		
		i=0;
		
		$scope.speaker.schedule.forEach(function(schedule){
			if($scope.days.indexOf(Date.parse(schedule.date)) == -1)
			{
				$scope.days.push(Date.parse(schedule.date));
			}
			
			if($scope.times.length == 0)
			{
				$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});	
			}
			else
			{
				var foundSlot = false;
				
				$scope.times.forEach(function(timeSlot){
					if(timeSlot.date == schedule.date && timeSlot.start == schedule.start && timeSlot.end == schedule.end)
					{
						foundSlot = true;
					}
				});
				
				if(!foundSlot)
				{
					$scope.times.push({date: schedule.date, start: schedule.start, end: schedule.end});
				}
			}
			
			if(sessionsScheduled.indexOf(schedule.id) != -1)
			{
				$scope.speaker.schedule[i].added = 1;
			}
			else
			{
				$scope.speaker.schedule[i].added = 0;
			}
			
			i++;			
		});		
	});
	
	$scope.addToSchedule = function(e, id){
		e.preventDefault();
		
		db = $cordovaSQLite.openDB({ name: "sesconference2016.db", location: 'default' });
		
		if(sessionsScheduled.indexOf(id) != -1)
		{
			query = "DELETE FROM myschedule WHERE id = ?";
			
			$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
				sessionsScheduled.splice(sessionsScheduled.indexOf(id), 1);
				$rootScope.$broadcast('scheduleRefresh');
				
				i=0;
				
				$scope.speaker.schedule.forEach(function(schedule){
					if(schedule.id == id)
					{
						$scope.speaker.schedule[i].added = 0;
					}
					
					i++;
				});
									
	    	}, function (err) {
	    	});				
		}
		else
		{
			query = "INSERT OR IGNORE INTO myschedule (id) VALUES (?)";
			
			$cordovaSQLite.execute(db, query, [id]).then(function(res) {	
				sessionsScheduled.push(id);	
				$rootScope.$broadcast('scheduleRefresh');
				
				i=0;
				
				$scope.speaker.schedule.forEach(function(schedule){
					
					if(schedule.id == id)
					{
						$scope.speaker.schedule[i].added = 1;
					}
					
					i++;
				});
									
	    	}, function (err) {
	    	});			
		}
		
		$rootScope.$broadcast('scheduleRefresh');	
	}	
	
	$scope.shortenBiography = function(){
		if($scope.speaker.biography.length > 80)
		{
			return true;
		}
	}
	
	$scope.toggleBiography = function(){
		
		if($scope.expanded)
		{
			var el = $('.biography'),
			    curHeight = el.height(),
			    autoHeight = 100;
			el.height(curHeight).animate({height: autoHeight}, 1000);	
			
			$scope.expanded = false;			
		}
		else
		{
			var el = $('.biography'),
			    curHeight = el.height(),
			    autoHeight = el.css('height', 'auto').height();
			el.height(curHeight).animate({height: autoHeight}, 1000);	
			
			$scope.expanded = true;		
		}
	}
		
	$scope.goBack = function(){
		$ionicHistory.goBack();
	}
	
	$scope.sortDays = function(day){
		var date = new Date(day);
		return date;  
	}
	
	$scope.sortTimes = function(timeSlot){
		var time = new Date(timeSlot.date + ' ' + timeSlot.start);
		
		return time;
	}
	
	$scope.filterSchedule = function(day, startTime){
		return function(item){
			var found = false;
			
			if(Date.parse(item.date) == day && item.start == startTime)
			{
				found = true;
			}
			
			return found;
		}		
	}
	
	$scope.filterTime = function(day){
		return function(time){
			var found = false;
			
			if(Date.parse(time.date) == day)
			{
				found = true;
			}
			
			return found;
		}
	}
	
   jQuery(document).on('click', '.external-link', function (e) {
	  e.preventDefault();
      var link = $(this).attr('href');
      window.open(link, '_system', 'location=yes');
     return false;
   });			
})
.controller('MapCtrl', function($scope, $stateParams, $ionicModal, $timeout, $rootScope, Maps, SocialMediaPost) {
    $scope.shareGenericPost = function(){
	    SocialMediaPost.signalGenericPost();
    }
    
	$rootScope.$on('mapRefresh', function(){
		Maps.fetchAll().then(function(data){
			$scope.maps = data;
			
			mapsCache = $scope.maps;							
		});	
	});    	
    	
	if(mapsCache)
	{
		$scope.maps = mapsCache;
	}
	else
	{
		Maps.fetchAll().then(function(data){
			$scope.maps = data;
			
			mapsCache = $scope.maps;							
		});		
    }  
    
    $scope.showMap = function(e, url){
	    e.preventDefault();

	    if(ionic.Platform.isIOS())
	    {
	    	fileUrl = url
	    	window.open(fileUrl, '_blank', 'location=no,EnableViewPortScale=yes');
	    }
	    else
	    {
			fileUrl = url;
			window.open('https://docs.google.com/viewer?url=' + fileUrl + '&embedded=true', '_blank', 'location=no');
	    }				    
    }
    
  $scope.closeModal = function(e) {
	e.preventDefault();
	
    $scope.modal.hide();
    
    $timeout(function(){
	    $scope.modal.remove();
    }, 500)
  };    
})
.controller('SurveyCtrl', function($scope, $stateParams, $timeout, $ionicLoading, $cordovaSQLite, Schedule) {
	$scope.surveySubmitted = false;
	
	$scope.previousSlide = function(e){
		e.preventDefault();
		
		$scope.slider.slidePrev();
	}
	
	$scope.nextSlide = function(e, option){
		e.preventDefault();
		
		$scope.slider.slideNext();
	};	
		
	$timeout(function(){
		rangeOne = document.getElementById('range-slider1');
		rangeTwo = document.getElementById('range-slider2');
		rangeThree = document.getElementById('range-slider3');
		
		noUiSlider.create(rangeOne, {
			start: 1, // Handle start position
			step: 1, // Slider moves in increments of '10'
			margin: 1, // Handles must be more than '20' apart
			direction: 'rtl', // Put '0' at the bottom of the slider
			orientation: 'vertical', // Orient the slider vertically
			range: { // Slider can select '0' to '100'
				'min': 1,
				'max': 5
			},
			pips: { // Show a scale with the slider
				mode: 'steps',
				density: 1
			}
		});
		
		noUiSlider.create(rangeTwo, {
			start: 1, // Handle start position
			step: 1, // Slider moves in increments of '10'
			margin: 1, // Handles must be more than '20' apart
			direction: 'rtl', // Put '0' at the bottom of the slider
			orientation: 'vertical', // Orient the slider vertically
			range: { // Slider can select '0' to '100'
				'min': 1,
				'max': 5
			},
			pips: { // Show a scale with the slider
				mode: 'steps',
				density: 1
			}
		});
		
		noUiSlider.create(rangeThree, {
			start: 1, // Handle start position
			step: 1, // Slider moves in increments of '10'
			margin: 1, // Handles must be more than '20' apart
			direction: 'rtl', // Put '0' at the bottom of the slider
			orientation: 'vertical', // Orient the slider vertically
			range: { // Slider can select '0' to '100'
				'min': 1,
				'max': 5
			},
			pips: { // Show a scale with the slider
				mode: 'steps',
				density: 1
			}
		});				
	}, 500);
	
	$scope.submitSurvey = function(e){
		e.preventDefault();
		
		$ionicLoading.show({
			content: 'Loading',
			animation: 'fade-in',
			showBackdrop: true,
			maxWidth: 200,
			showDelay: 0
		});
				
		Schedule.insertSurvey($scope.schedule.singleTitle, parseInt(rangeOne.noUiSlider.get()), parseInt(rangeTwo.noUiSlider.get()), parseInt(rangeThree.noUiSlider.get())).then(function(response){
			$scope.surveySubmitted = true;
			
			db = $cordovaSQLite.openDB({ name: "sesconference2016.db", location: 'default' });
			query = "INSERT OR IGNORE INTO surveycompleted (id) VALUES (?)";
			$cordovaSQLite.execute(db, query, [$scope.schedule.id]).then(function(res) {	
				$ionicLoading.hide();
				surveysTaken.push($scope.schedule.id);
				$scope.surveyButton.show = false;
	    	}, function (err) {
	    	});				
		});		
	}
	
})
.controller('SpeakersCtrl', function($scope, $stateParams, Speakers) {
})
.controller('SponsorsCtrl', function($scope, $stateParams, $rootScope, Sponsors, SocialMediaPost) {
	$rootScope.$on('sponsorRefresh', function(){
		Sponsors.fetchAll().then(function(data){
			$scope.sponsors = data;
			
			sponsorCache = $scope.sponsors;							
		});	
	});
		
    $scope.shareGenericPost = function(){
	    SocialMediaPost.signalGenericPost();
    }	
    	
	if(sponsorCache)
	{
		$scope.sponsors = sponsorCache;
	}
	else
	{
		Sponsors.fetchAll().then(function(data){
			$scope.sponsors = data;
			
			sponsorCache = $scope.sponsors;							
		});		
    }    
})
.controller('SingleSponsorCtrl', function($scope, $stateParams, $ionicModal, $timeout, $ionicHistory, $cordovaFileOpener2, Sponsors) {
 	Sponsors.fetchSingle($stateParams.sponsorId).then(function(data){
		$scope.sponsor = data;
	});
	
	$scope.goBack = function(){
		$ionicHistory.goBack();
	}	
	
	$scope.openWebsiteLink = function(e, url){
		e.preventDefault();
		
		window.open(url, '_system', 'location=yes');
	} 
	$scope.displayOffer = function(e, type){
	    e.preventDefault();
		
		if(type == 'pdf')
		{
		    if(ionic.Platform.isIOS())
		    {
		    	fileUrl = $scope.sponsor.offerUrl;
		    	window.open(fileUrl, '_blank', 'location=no,EnableViewPortScale=yes');
		    }
		    else
		    {
				fileUrl = $scope.sponsor.offerUrl;
				window.open('https://docs.google.com/viewer?url=' + fileUrl + '&embedded=true', '_blank', 'location=no');
		    }
		}
		else
		{
			window.open($scope.sponsor.offerUrl, '_system', 'location=yes');
		}		    	    
	}
	    
	  $scope.closeModal = function(e) {
		e.preventDefault();
		
	    $scope.modal.hide();
	    
	    $timeout(function(){
		    $scope.modal.remove();
	    }, 500)
	  };
	  
   jQuery(document).on('click', '.external-link', function (e) {
	  e.preventDefault();
      var link = $(this).attr('href');
      window.open(link, '_system', 'location=yes');
     return false;
   });	 
   	  	
})
.controller('LivestreamCtrl', function($scope, $stateParams, $rootScope, $ionicLoading, SocialMediaPost, Livestream, ionicToast, $cordovaSQLite) {
	$scope.showSubmit = false;
	$scope.form = {};
	$scope.form.code = '';
	$scope.redeemedCode = false;
	
	$rootScope.$on('livestreamRefresh', function(){
		$scope.redeemedCode = true;
	});	
	
    if(redeemedCode == true)
    {
	    $scope.redeemedCode = true;
    }
    else
    {
	    $scope.redeemedCode = false;
    }	
	
	$scope.checkSubmit = function(){
		if($scope.form.code == '')
		{
			$scope.showSubmit = false;
		}
		else
		{
			$scope.showSubmit = true;
		}
	}
	
    $scope.shareGenericPost = function(){
	    SocialMediaPost.signalGenericPost();
    }	
    	
	$scope.playVideo = function(e){
		e.preventDefault();
		
		if(ionic.Platform.isIOS())
		{
			window.plugins.streamingMedia.playVideo('http://yourstreamlive.com/live/4442/hls');
		}
		else
		{
			window.plugins.streamingMedia.playVideo('http://edge-4442.yourstreamlive.com:1935/live/yourstreamlive/amlst:out_4442_4hcmexrmkc5ww/playlist.m3u8');
		}	
	}
	
	$scope.checkActivationCode = function(){
		var codeInput = angular.element(document.querySelector('#activation-code'));
		codeInput[0].blur();
		
		$ionicLoading.show({
			content: 'Loading',
			animation: 'fade-in',
			showBackdrop: true,
			maxWidth: 200,
			showDelay: 0
		});
				
		Livestream.checkCode($scope.form.code).then(function(response){
			$scope.surveySubmitted = true;

			$ionicLoading.hide();
			
			//Code has already been redeemed...
			if(response.result == "3")
			{
				ionicToast.show('Your code has already been redeemed.', 'bottom', true, 2500);
			}
			//Code is invalid...
			else if(response.result == "2")
			{
				ionicToast.show('Your code is invalid.', 'bottom', true, 2500);
			}
			else
			{			
				db = $cordovaSQLite.openDB({ name: "sesconference2016.db", location: 'default' });
				query = "INSERT OR IGNORE INTO livestream (id) VALUES (?)";
				$cordovaSQLite.execute(db, query, [$scope.form.code]).then(function(res) {	
					$ionicLoading.hide();
					redeemedCode = true;
					$scope.redeemedCode = true;
		    	}, function (err) {
		    	});	
		    }	
		});			
	}
			
	$scope.openSupportEmail = function(e){
		e.preventDefault();
		
		window.open('mailto:ses.livestream@cacpro.com', '_system', 'location=yes');
	}		
});
