var newsCache, newsMoreData, newsCurrentPage;
var optionsCache;
var mapsCache;
var sponsorCache;
var speakerCache;
var scheduleCache;
var surveysTaken = [];
var sessionsScheduled = [];
var redeemedCode = false;

angular.module('starter.services', [])

.factory('Options', function($q, $http, ENVIRONMENT) {
	return {
				fetchAll: function(page) {
					var promise = $http.get(ENVIRONMENT.url + '?action=fetchoptions').then(function (response) {
						return response.data;
					});
			
					return promise;
				}
			}	
})
.factory('SocialMediaPost', function($cordovaSocialSharing){
	return {
				signalGenericPost: function(){
					$cordovaSocialSharing
						.share(optionsCache.genericpostdefault) // Share via native share sheet
						.then(function(result) {
						// Success!
						}, function(err) {
						// An error occured. Show a message to the user
					});					
				},
				signalSinglePost: function(title){
					$cordovaSocialSharing
						.share(title + '\n' + optionsCache.singlenewsdefault) // Share via native share sheet
						.then(function(result) {
						// Success!
						}, function(err) {
						// An error occured. Show a message to the user
					});					
				}
			}
})
.factory('News', function($q, $http, ENVIRONMENT) {
	return {
				fetchAll: function(page) {
					var promise = $http.get(ENVIRONMENT.url + '?action=fetchnews&page=' + page).then(function (response) {
						return response.data;
					});
			
					return promise;
				},
				getNews: function(newsId){
					var dfd = $q.defer();
					
					newsCache.forEach(function(news){
						if(news.id == newsId)
						{
							dfd.resolve(news);
						}
					})
					
					return dfd.promise;
				}
			}	
})
.factory('Maps', function($q, $http, ENVIRONMENT) {
	return {
				fetchAll: function(page) {
					var promise = $http.get(ENVIRONMENT.url + '?action=fetchmaps').then(function (response) {
						return response.data;
					});
			
					return promise;
				}
			}	
})
.factory('Sponsors', function($q, $http, ENVIRONMENT) {
	return {
				fetchAll: function(page) {
					var promise = $http.get(ENVIRONMENT.url + '?action=fetchsponsors').then(function (response) {
						return response.data;
					});
			
					return promise;
				},
				fetchSingle: function(sponsorId) {
					var dfd = $q.defer();
					
					sponsorCache.forEach(function(sponsor){
						if(sponsor.id == sponsorId)
						{
							dfd.resolve(sponsor);
						}
					})
					
					return dfd.promise;					
				}
			}	
})
.factory('Speakers', function($q, $http, ENVIRONMENT) {
	return {
				fetchAll: function() {
					var promise = $http.get(ENVIRONMENT.url + '?action=fetchspeakers').then(function (response) {
						return response.data;
					});
			
					return promise;
				},
				fetchSingle: function(speakerId) {
					var dfd = $q.defer();
					
					speakerCache.forEach(function(speaker){
						if(speaker.id == speakerId)
						{
							dfd.resolve(speaker);
						}
					})
					
					return dfd.promise;					
				}
			}	
})
.factory('Schedule', function($q, $http, ENVIRONMENT) {
	return {
				fetchAll: function() {
					var promise = $http.get(ENVIRONMENT.url + '?action=fetchschedule').then(function (response) {
						return response.data;
					});
			
					return promise;
				},
				fetchSingle: function(scheduleId) {
					var dfd = $q.defer();
					
					scheduleCache.forEach(function(schedule){
						if(schedule.id == scheduleId)
						{
							dfd.resolve(schedule);
						}
					})
					
					return dfd.promise;					
				},
				insertSurvey: function(title, contentsatisfaction, engagesatisfaction, difficultysatisfaction){
					url = ENVIRONMENT.url + '?action=insertsurveyresult';
					var defer = $q.defer();
					
					var promise = $http({method: 'POST', url: url, data: {title: title, contentsatisfaction: contentsatisfaction, engagesatisfaction: engagesatisfaction, difficultysatisfaction: difficultysatisfaction, secret: ENVIRONMENT.secret}, headers: {'Content-Type': 'application/x-www-form-urlencoded'}}).success(function(data){
						defer.resolve(data);
					});
					
					return defer.promise;					
				}
			}	
})
.factory('Livestream', function($q, $http, ENVIRONMENT) {
	return {
				checkCode: function(code){
					url = ENVIRONMENT.url + '?action=checkcode';
					var defer = $q.defer();
					
					var promise = $http({method: 'POST', url: url, data: {code: code, secret: ENVIRONMENT.secret}, headers: {'Content-Type': 'application/x-www-form-urlencoded'}}).success(function(data){
						defer.resolve(data);
					});
					
					return defer.promise;					
				}
			}	
});